import { W as ue, w as k, a4 as o, X as b, bY as fe, a9 as ye, V as R, cf as B, a5 as x, cg as he, aH as Se, ch as we, S as ge, ci as Ve, cj as ve, aa as A, ab as V, ck as W, U as j, cl as i, cm as m, H as u, c6 as H, cn as p, ad as c, I as v, ae as s, af as d, co as N, an as l, cp as _, c1 as L, ah as $, ag as Y, cq as G, cr as Z, c4 as Q, cs as be, ai as X, ct as f, cu as E, c2 as J, cv as Te, cw as Ze, P as Ce, _ as xe, cx as De, cy as Me, cz as Pe, cA as Re, cB as Ee, cC as Fe, cD as Ie, cE as O, cF as ke, cG as Be, cH as Oe } from "./c8cb6565.js";
import { useState as z, useEffect as T, useContext as r } from "react";
import { disabledTime as ee, handleDateChange as F, dateRefMethods as te } from "./69365736.js";
import { DateUIView as ze } from "./64753d10.js";
import { DateRangeUIView as Ke } from "./ff75f540.js";
import { timeZoneOptions as qe } from "./954f6cfa.js";
import "react-dom";
import "./54762cf9.js";
const Ae = [ke, Be, Oe], Ue = [{
  label: "Date",
  value: "date"
}, {
  label: "Week",
  value: "week"
}, {
  label: "Month",
  value: "month"
}, {
  label: "Quarter",
  value: "quarter"
}, {
  label: "Year",
  value: "year"
}], We = {
  showValidationWhenEmpty: R,
  required: R,
  minDate: b,
  maxDate: b,
  minTime: b,
  maxTime: b,
  customRule: Ze
}, ae = {
  label: ue,
  placeholder: k(b, o("date.placeholder")),
  format: b,
  inputFormat: k(b, Z),
  disabled: fe,
  onEvent: ye(Ae),
  showTime: R,
  use12Hours: R,
  hourStep: B.closed(1, 24, 1),
  minuteStep: B.closed(1, 60, 1),
  secondStep: B.closed(1, 60, 1),
  style: x(he, "style"),
  animationStyle: x(Se, "animationStyle"),
  labelStyle: x(we.filter((e) => ["accent", "validate"].includes(e.name) === !1), "labelStyle"),
  suffixIcon: k(Ce, "/icon:regular/calendar"),
  ...We,
  viewRef: ge,
  inputFieldStyle: x(Ve, "inputFieldStyle"),
  childrenInputFieldStyle: x(ve, "childrenInputFieldStyle"),
  timeZone: A(qe, Intl.DateTimeFormat().resolvedOptions().timeZone),
  pickerMode: A(Ue, "date")
}, oe = (e) => xe.pick(e, "format", "inputFormat", "showTime", "use12Hours", "hourStep", "minuteStep", "secondStep", "placeholder", "pickerMode"), ne = (e, t) => [e.showTime.propertyView({
  label: o("date.showTime")
}), !t && e.use12Hours.propertyView({
  label: o("prop.use12Hours")
})], le = (e, t = !0) => {
  if (t && e.showTime.getView())
    return /* @__PURE__ */ c(s, {
      name: d.advanced,
      children: [De(e), Me(e), Pe(e)]
    });
}, re = (e, t = "date") => {
  if (t === "date")
    return [Re(e), Ee(e)];
}, ie = (e, t = "date") => {
  if (t === "date" && e.showTime.getView())
    return [Fe(e), Ie(e)];
};
function C(e) {
  if (e.customRule)
    return {
      validateStatus: "error",
      help: e.customRule
    };
  const t = i(e.value.value, m);
  return e.required && (e.value.value === "" || !t.isValid()) ? {
    validateStatus: "error",
    help: o("prop.required")
  } : {
    validateStatus: "success"
  };
}
const je = {
  defaultValue: V("defaultValue"),
  value: V("value"),
  userTimeZone: V("userTimeZone", Intl.DateTimeFormat().resolvedOptions().timeZone),
  ...ae,
  ...W
}, K = (e, t, a) => {
  let n;
  if (e != null && e.isValid())
    switch (a) {
      case "week": {
        n = i(e).day(0);
        break;
      }
      case "month": {
        n = i(e).set("date", 1);
        break;
      }
      case "quarter": {
        n = i(e).set("date", 1);
        break;
      }
      case "year": {
        n = i(e).set("date", 1).set("month", 1);
        break;
      }
      default: {
        n = e;
        break;
      }
    }
  return n ? n.format(t ? E : Z) : "";
}, He = new j(je, (e) => {
  const t = {
    ...e.defaultValue
  }.value, a = {
    ...e.value
  }.value;
  let n = null;
  a !== "" && (n = i(a, m));
  const [y, h] = z(n);
  T(() => {
    e.value.onChange(t);
  }, [t]), T(() => {
    const S = a ? i(a, m) : null;
    h(S);
  }, [a]);
  const g = (S) => {
    e.userTimeZone.onChange(S);
  };
  return e.label({
    required: e.required,
    style: e.style,
    labelStyle: e.labelStyle,
    inputFieldStyle: e.inputFieldStyle,
    animationStyle: e.animationStyle,
    onMouseDown: (S) => S.stopPropagation(),
    children: /* @__PURE__ */ u(ze, {
      onClickDateTimeZone: g,
      timeZone: e.timeZone,
      viewRef: e.viewRef,
      disabledTime: () => ee(e.minTime, e.maxTime),
      $style: e.inputFieldStyle,
      $childrenInputFieldStyle: e.childrenInputFieldStyle,
      disabled: e.disabled,
      ...oe(e),
      hourStep: e.hourStep,
      minDate: e.minDate,
      maxDate: e.maxDate,
      placeholder: e.placeholder,
      value: y != null && y.isValid() ? y : null,
      onChange: (S) => {
        F(K(S, e.showTime, e.pickerMode), e.value.onChange, e.onEvent);
      },
      onPanelChange: () => {
        F("", e.value.onChange, O.noop);
      },
      onFocus: () => e.onEvent("focus"),
      onBlur: () => e.onEvent("blur"),
      suffixIcon: H(e.suffixIcon) && e.suffixIcon
    }),
    showValidationWhenEmpty: e.showValidationWhenEmpty,
    ...C(e)
  });
}).setPropertyViewFn((e) => {
  const t = p();
  return /* @__PURE__ */ c(v, {
    children: [/* @__PURE__ */ c(s, {
      name: d.basic,
      children: [e.defaultValue.propertyView({
        label: o("prop.defaultValue"),
        placeholder: "2022-04-07 21:39:59",
        tooltip: o("date.formatTip")
      }), e.pickerMode.propertyView({
        label: o("prop.pickerMode")
      }), e.timeZone.propertyView({
        label: o("prop.timeZone")
      })]
    }), /* @__PURE__ */ u(N, {
      ...e
    }), (r(l).editorModeStatus === "logic" || r(l).editorModeStatus === "both") && /* @__PURE__ */ c(v, {
      children: [/* @__PURE__ */ c(s, {
        name: d.validation,
        children: [_(e), e.showValidationWhenEmpty.propertyView({
          label: o("prop.showEmptyValidation")
        }), re(e), ie(e), e.customRule.propertyView({})]
      }), /* @__PURE__ */ c(s, {
        name: d.interaction,
        children: [e.onEvent.getPropertyView(), L(e), $(e), Y(e)]
      })]
    }), (r(l).editorModeStatus === "layout" || r(l).editorModeStatus === "both") && e.label.getPropertyView(), (r(l).editorModeStatus === "layout" || r(l).editorModeStatus === "both") && /* @__PURE__ */ c(s, {
      name: d.layout,
      children: [G({
        children: e,
        placeholder: Z
      }), e.placeholder.propertyView({
        label: o("date.placeholderText")
      })]
    }), (r(l).editorModeStatus === "logic" || r(l).editorModeStatus === "both") && /* @__PURE__ */ u(v, {
      children: /* @__PURE__ */ c(s, {
        name: d.advanced,
        children: [ne(e, t), e.suffixIcon.propertyView({
          label: o("button.suffixIcon")
        })]
      })
    }), (r(l).editorModeStatus === "logic" || r(l).editorModeStatus === "both") && !t && le(e), (r(l).editorModeStatus === "layout" || r(l).editorModeStatus === "both") && /* @__PURE__ */ c(v, {
      children: [/* @__PURE__ */ u(s, {
        name: d.style,
        children: e.style.getPropertyView()
      }), /* @__PURE__ */ u(s, {
        name: d.labelStyle,
        children: e.labelStyle.getPropertyView()
      }), /* @__PURE__ */ u(s, {
        name: d.inputFieldStyle,
        children: e.inputFieldStyle.getPropertyView()
      }), /* @__PURE__ */ u(s, {
        name: d.childrenInputFieldStyle,
        children: e.childrenInputFieldStyle.getPropertyView()
      }), /* @__PURE__ */ u(s, {
        name: d.animationStyle,
        hasTooltip: !0,
        children: e.animationStyle.getPropertyView()
      })]
    })]
  });
}).setExposeMethodConfigs(te).build(), pe = Q(He, be);
function Ne(e) {
  if (!e)
    return e;
  let {
    defaultStart: t,
    defaultEnd: a
  } = e;
  return e.start && !e.defaultStart && (t = e.start), e.end && !e.defaultEnd && (a = e.end), {
    ...e,
    defaultStart: t,
    defaultEnd: a,
    start: "",
    end: ""
  };
}
let _e = function() {
  const e = {
    defaultStart: V("defaultStart"),
    start: V("start"),
    defaultEnd: V("defaultEnd"),
    end: V("end"),
    userRangeTimeZone: V("userRangeTimeZone", Intl.DateTimeFormat().resolvedOptions().timeZone),
    ...W,
    ...ae
  };
  return new j(e, (t) => {
    const a = {
      ...t.defaultStart
    }.value, n = {
      ...t.start
    }.value, y = {
      ...t.defaultEnd
    }.value, h = {
      ...t.end
    }.value;
    let g = null;
    n !== "" && (g = i(n, m));
    let S = null;
    h !== "" && (S = i(h, m));
    const [D, de] = z(g), [M, me] = z(S);
    T(() => {
      t.start.onChange(a);
    }, [a]), T(() => {
      t.end.onChange(y);
    }, [y]), T(() => {
      const w = n ? i(n, m) : null;
      de(w);
    }, [n]), T(() => {
      const w = h ? i(h, m) : null;
      me(w);
    }, [h]);
    const ce = /* @__PURE__ */ u(Ke, {
      onClickDateRangeTimeZone: (w) => {
        t.userRangeTimeZone.onChange(w);
      },
      timeZone: t == null ? void 0 : t.timeZone,
      viewRef: t.viewRef,
      $style: t.inputFieldStyle,
      $childrenInputFieldStyle: t.childrenInputFieldStyle,
      disabled: t.disabled,
      ...oe(t),
      start: D != null && D.isValid() ? D : null,
      end: M != null && M.isValid() ? M : null,
      minDate: t.minDate,
      maxDate: t.maxDate,
      placeholder: [t.placeholder, t.placeholder],
      disabledTime: () => ee(t.minTime, t.maxTime),
      onChange: (w, P) => {
        t.start.onChange(K(w, t.showTime, t.pickerMode)), t.end.onChange(K(P, t.showTime, t.pickerMode)), t.onEvent("change");
      },
      onPanelChange: (w, P) => {
        P[0] !== "date" && F("", t.start.onChange, O.noop), P[1] !== "date" && F("", t.end.onChange, O.noop);
      },
      onFocus: () => t.onEvent("focus"),
      onBlur: () => t.onEvent("blur"),
      suffixIcon: H(t.suffixIcon) && t.suffixIcon
    }), I = C({
      ...t,
      value: t.start
    }), q = C({
      ...t,
      value: t.end
    });
    return t.label({
      required: t.required,
      style: t.style,
      labelStyle: t.labelStyle,
      children: ce,
      inputFieldStyle: t.inputFieldStyle,
      onMouseDown: (w) => w.stopPropagation(),
      showValidationWhenEmpty: t.showValidationWhenEmpty,
      ...I.validateStatus !== "success" ? I : q.validateStatus !== "success" ? q : I
    });
  }).setPropertyViewFn((t) => {
    const a = p();
    return /* @__PURE__ */ c(v, {
      children: [/* @__PURE__ */ c(s, {
        name: d.basic,
        children: [t.defaultStart.propertyView({
          label: o("date.start"),
          placeholder: "2022-04-07 21:39:59",
          tooltip: o("date.formatTip")
        }), t.defaultEnd.propertyView({
          label: o("date.end"),
          placeholder: "2022-04-07 21:39:59",
          tooltip: o("date.formatTip")
        }), t.pickerMode.propertyView({
          label: o("prop.pickerMode")
        }), t.timeZone.propertyView({
          label: o("prop.timeZone")
        })]
      }), /* @__PURE__ */ u(N, {
        ...t
      }), (r(l).editorModeStatus === "logic" || r(l).editorModeStatus === "both") && /* @__PURE__ */ c(v, {
        children: [/* @__PURE__ */ c(s, {
          name: d.validation,
          children: [_(t), t.showValidationWhenEmpty.propertyView({
            label: o("prop.showEmptyValidation")
          }), re(t), ie(t), t.customRule.propertyView({})]
        }), /* @__PURE__ */ c(s, {
          name: d.interaction,
          children: [t.onEvent.getPropertyView(), L(t), $(t), Y(t)]
        })]
      }), (r(l).editorModeStatus === "layout" || r(l).editorModeStatus === "both") && t.label.getPropertyView(), (r(l).editorModeStatus === "layout" || r(l).editorModeStatus === "both") && /* @__PURE__ */ c(s, {
        name: d.layout,
        children: [G({
          children: t
        }), t.placeholder.propertyView({
          label: o("date.placeholderText")
        })]
      }), (r(l).editorModeStatus === "logic" || r(l).editorModeStatus === "both") && /* @__PURE__ */ u(v, {
        children: /* @__PURE__ */ c(s, {
          name: d.advanced,
          children: [ne(t, a), t.suffixIcon.propertyView({
            label: o("button.suffixIcon")
          })]
        })
      }), (r(l).editorModeStatus === "logic" || r(l).editorModeStatus === "both") && le(t), (r(l).editorModeStatus === "layout" || r(l).editorModeStatus === "both") && /* @__PURE__ */ c(v, {
        children: [/* @__PURE__ */ u(s, {
          name: d.style,
          children: t.style.getPropertyView()
        }), /* @__PURE__ */ u(s, {
          name: d.labelStyle,
          children: t.labelStyle.getPropertyView()
        }), /* @__PURE__ */ u(s, {
          name: d.inputFieldStyle,
          children: t.inputFieldStyle.getPropertyView()
        }), /* @__PURE__ */ u(s, {
          name: d.childrenInputFieldStyle,
          children: t.childrenInputFieldStyle.getPropertyView()
        })]
      })]
    });
  }).build();
}();
const Le = Q(_e, Ne), se = (e, t) => {
  var g;
  const a = e === "UserChoice" ? t : e, y = i().tz(a).format("Z"), h = (g = new Intl.DateTimeFormat("en-US", {
    timeZone: a,
    timeZoneName: "short"
  }).formatToParts().find((S) => S.type === "timeZoneName")) == null ? void 0 : g.value;
  return {
    TimeZone: a,
    Offset: y,
    Name: h
  };
}, ot = X(pe, [f({
  name: "value",
  desc: o("export.datePickerValueDesc"),
  depKeys: ["value", "showTime"],
  func: (e) => {
    const t = e.value ? i(e.value, m) : null;
    return t != null && t.isValid() ? t.format(e.showTime ? E : Z) : null;
  }
}), f({
  name: "formattedValue",
  desc: o("export.datePickerFormattedValueDesc"),
  depKeys: ["value", "format", "timeZone", "userTimeZone"],
  func: (e) => {
    const t = e.value ? i(e.value, m) : null, a = e.timeZone === "UserChoice" ? e.userTimeZone : e.timeZone, n = t == null ? void 0 : t.clone().tz(a, !0);
    return t != null && t.isValid() ? !e.format || e.format.includes("Z") || e.format.includes("z") ? n == null ? void 0 : n.format(e == null ? void 0 : e.format) : t.format(e.format) : "";
  }
}), f({
  name: "timestamp",
  desc: o("export.datePickerTimestampDesc"),
  depKeys: ["value"],
  func: (e) => {
    const t = e.value ? i(e.value, m) : null;
    return t != null && t.isValid() ? t.unix() : "";
  }
}), f({
  name: "invalid",
  desc: o("export.invalidDesc"),
  depKeys: ["value", "required", "minTime", "maxTime", "minDate", "maxDate", "customRule"],
  func: (e) => C({
    ...e,
    value: {
      value: e.value
    }
  }).validateStatus !== "success"
}), f({
  name: "timeZone",
  desc: o("export.timeZoneDesc"),
  depKeys: ["timeZone", "userTimeZone"],
  func: (e) => se(e.timeZone, e.userTimeZone)
}), ...J]);
let U = X(Le, [f({
  name: "start",
  desc: o("export.dateRangeStartDesc"),
  depKeys: ["start", "showTime"],
  func: (e) => {
    const t = e.start ? i(e.start, m) : null;
    return t != null && t.isValid() ? t.format(e.showTime ? E : Z) : null;
  }
}), f({
  name: "end",
  desc: o("export.dateRangeEndDesc"),
  depKeys: ["end", "showTime"],
  func: (e) => {
    const t = e.end ? i(e.end, m) : null;
    return t != null && t.isValid() ? t.format(e.showTime ? E : Z) : null;
  }
}), f({
  name: "startTimestamp",
  desc: o("export.dateRangeStartTimestampDesc"),
  depKeys: ["start"],
  func: (e) => {
    const t = e.start ? i(e.start, m) : null;
    return t != null && t.isValid() ? t.unix() : "";
  }
}), f({
  name: "endTimestamp",
  desc: o("export.dateRangeEndTimestampDesc"),
  depKeys: ["end"],
  func: (e) => {
    const t = e.end ? i(e.end, m) : null;
    return t != null && t.isValid() ? t.unix() : "";
  }
}), f({
  name: "formattedValue",
  desc: o("export.dateRangeFormattedValueDesc"),
  depKeys: ["start", "end", "format", "timeZone", "userRangeTimeZone"],
  func: (e) => {
    const t = e.start ? i(e.start, m) : null, a = e.end ? i(e.end, m) : null, n = e.timeZone === "UserChoice" ? e.userRangeTimeZone : e.timeZone, y = t == null ? void 0 : t.clone().tz(n, !0), h = a == null ? void 0 : a.clone().tz(n, !0);
    return [t != null && t.isValid() && (!e.format || e.format.includes("Z") || e.format.includes("z")) ? y == null ? void 0 : y.format(e == null ? void 0 : e.format) : t == null ? void 0 : t.format(e.format), a != null && a.isValid() && (!e.format || e.format.includes("Z") || e.format.includes("z")) ? h == null ? void 0 : h.format(e == null ? void 0 : e.format) : a == null ? void 0 : a.format(e.format)].filter((g) => g).join(" - ");
  }
}), f({
  name: "formattedStartValue",
  desc: o("export.dateRangeFormattedStartValueDesc"),
  depKeys: ["start", "format", "timeZone", "userRangeTimeZone"],
  func: (e) => {
    const t = e.start ? i(e.start, m) : null, a = e.timeZone === "UserChoice" ? e.userRangeTimeZone : e.timeZone, n = t == null ? void 0 : t.clone().tz(a, !0);
    return t != null && t.isValid() && (!e.format || e.format.includes("Z") || e.format.includes("z")) ? n == null ? void 0 : n.format(e == null ? void 0 : e.format) : t == null ? void 0 : t.format(e.format);
  }
}), f({
  name: "formattedEndValue",
  desc: o("export.dateRangeFormattedEndValueDesc"),
  depKeys: ["end", "format", "timeZone", "userRangeTimeZone"],
  func: (e) => {
    const t = e.end ? i(e.end, m) : null, a = e.timeZone === "UserChoice" ? e.userRangeTimeZone : e.timeZone, n = t == null ? void 0 : t.clone().tz(a, !0);
    return t != null && t.isValid() && (!e.format || e.format.includes("Z") || e.format.includes("z")) ? n == null ? void 0 : n.format(e == null ? void 0 : e.format) : t == null ? void 0 : t.format(e.format);
  }
}), f({
  name: "timeZone",
  desc: o("export.timeZoneDesc"),
  depKeys: ["timeZone", "userRangeTimeZone"],
  func: (e) => se(e.timeZone, e.userRangeTimeZone)
}), f({
  name: "invalid",
  desc: o("export.invalidDesc"),
  depKeys: ["start", "end", "required", "minTime", "maxTime", "minDate", "maxDate", "customRule"],
  func: (e) => C({
    ...e,
    value: {
      value: e.start
    }
  }).validateStatus !== "success" || C({
    ...e,
    value: {
      value: e.end
    }
  }).validateStatus !== "success"
}), ...J]);
U = Te(U, [...te, {
  method: {
    name: "clearAll",
    description: o("date.clearAllDesc"),
    params: []
  },
  execute: (e) => {
    e.children.start.getView().onChange(""), e.children.end.getView().onChange("");
  }
}, {
  method: {
    name: "resetAll",
    description: o("date.resetAllDesc"),
    params: []
  },
  execute: (e) => {
    e.children.start.getView().reset(), e.children.end.getView().reset();
  }
}, {
  method: {
    name: "setRange",
    params: []
  },
  execute: (e, t) => {
    if (t.length !== 1)
      return Promise.reject(o("formComp.valuesLengthError"));
    const a = t[0];
    if (typeof a != "object" || a === null || Array.isArray(a) || !a.hasOwnProperty("start") || !a.hasOwnProperty("end"))
      return Promise.reject(o("formComp.valueTypeError"));
    e.children.start.getView().onChange(a.start), e.children.end.getView().onChange(a.end);
  }
}]);
export {
  ot as DatePickerComp,
  U as DateRangeComp,
  pe as datePickerControl,
  Le as dateRangeControl,
  Ne as fixOldDateOrTimeRangeData
};
