import { fR as n, fS as a, aD as c, a3 as e, a5 as i, fT as s, c4 as g, d9 as t, dC as l, db as p, dD as u, c9 as $ } from "./c8cb6565.js";
import "react";
import "react-dom";
function b(r) {
  const o = r.background && n(r.background), d = r.background && a(r.background);
  return c`
    &&& {
      border-radius: ${r.radius};
      margin: ${r.margin};
      padding: ${r.padding};
      &:not(:disabled) {
        // click animation color
        --antd-wave-shadow-color: ${r.border};
        border-color: ${r.border};
        color: ${r.text};
        background: ${r.background};
        border-radius: ${r.radius};
        margin: ${r.margin};
        padding: ${r.padding};

        &:hover,
        &:focus {
          color: ${r.text};
          background-color: ${o};
          border-color: ${r.border === r.background ? o : r.border};
        }

        &:active {
          color: ${r.text};
          background-color: ${d};
          border-color: ${r.border === r.background ? d : r.border};
        }
      }
    }
  `;
}
const C = e($)`
  ${(r) => r.$buttonStyle && b(r.$buttonStyle)}
  width: 100%;
  height: auto;
  display: inline-flex;
  justify-content: center;
  align-items: center;
  overflow: hidden;
  span {
    overflow: hidden;
    text-overflow: ellipsis;
  }
  gap: 6px;
`, w = e.div`
  // The button component is disabled but can respond to drag & select events
  ${(r) => r.disabled && `
    cursor: not-allowed;
    button:disabled {
      pointer-events: none;
    }
  `};
`;
function f(r) {
  return r && (r.hasOwnProperty("backgroundColor") || r.hasOwnProperty("borderColor") || r.hasOwnProperty("color")) ? {
    background: r.backgroundColor,
    border: r.borderColor,
    text: r.color
  } : r;
}
const h = i(s), x = g(h, f), B = t([l, p, u]);
export {
  C as Button100,
  w as ButtonCompWrapper,
  x as ButtonStyleControl,
  B as buttonRefMethods,
  b as getButtonStyle
};
