import { useContext as p, useState as V, useEffect as I } from "react";
import { a3 as T, aE as S, aF as D, a4 as o, eN as E, aa as P, V as C, aI as j, w, X as H, a9 as O, a5 as B, eO as F, v as y, U as M, H as n, ad as c, I as h, ae as d, af as m, an as f, ah as A, ag as N, ai as U, ak as g, aj as G, c9 as W, aB as u, ej as X, eP as q, as as z } from "./c8cb6565.js";
import { timelineDate as J, TimelineDataTooltip as K } from "./386c960a.js";
import { convertTimeLineData as Q } from "./85945a20.js";
import "react-dom";
const R = T.div`
  ${(e) => `margin: ${e.$style.margin ?? "3px"}`};
  ${(e) => `padding: ${e.$style.padding !== "3px" ? e.$style.padding : "20px 10px 0px 10px"}`};
  ${(e) => `width: ${S(e.$style.margin ?? "3px")}`};
  ${(e) => `height: ${D(e.$style.margin ?? "3px")}`};
  ${(e) => `background: ${e.$style.background}`};
  ${(e) => `border-radius: ${e.$style.radius}`};
  overflow: auto;
  overflow-x: hidden;

  .ant-timeline .ant-timeline-item-head {
    background-color: transparent;
  }
`, Y = [z], Z = [{
  label: o("timeLine.left"),
  value: "left"
}, {
  label: o("timeLine.right"),
  value: "right"
}, {
  label: o("timeLine.alternate"),
  value: "alternate"
}], _ = {
  value: E(Q, J),
  mode: P(Z, "alternate"),
  reverse: C,
  autoHeight: j,
  verticalScrollbar: w(C, !1),
  pending: w(H, o("timeLine.defaultPending")),
  onEvent: O(Y),
  style: B(F, "style"),
  clickedObject: y({
    title: ""
  }),
  clickedIndex: y(0)
}, v = async (e) => {
  if (!e)
    return null;
  try {
    const r = (await import("./c8cb6565.js").then((i) => i.Gl))[e];
    return r ? /* @__PURE__ */ n(r, {}) : null;
  } catch (l) {
    return console.error(`Error loading icon ${e}:`, l), null;
  }
}, ee = (e) => {
  const {
    value: l,
    dispatch: r,
    style: i,
    mode: te,
    reverse: ie,
    onEvent: $
  } = e, [x, L] = V([]);
  I(() => {
    (async () => {
      const a = await Promise.all(l.map((s) => s.dot ? v(s.dot) : Promise.resolve(null)));
      L(a);
    })();
  }, [l]);
  const k = l.map((t, a) => ({
    key: a,
    color: t == null ? void 0 : t.color,
    dot: x[a] || "",
    label: /* @__PURE__ */ n("span", {
      style: {
        color: (t == null ? void 0 : t.labelColor) || (i == null ? void 0 : i.labelColor)
      },
      children: t == null ? void 0 : t.label
    }),
    children: /* @__PURE__ */ c(h, {
      children: [/* @__PURE__ */ n(W, {
        type: "link",
        onClick: (s) => {
          s.preventDefault(), r(u("clickedObject", t, !1)), r(u("clickedIndex", a, !1)), $("click");
        },
        style: {
          cursor: "pointer",
          color: (t == null ? void 0 : t.titleColor) || (i == null ? void 0 : i.titleColor)
        },
        children: /* @__PURE__ */ n("b", {
          children: t == null ? void 0 : t.title
        })
      }), /* @__PURE__ */ n("p", {
        style: {
          color: (t == null ? void 0 : t.subTitleColor) || (i == null ? void 0 : i.subTitleColor)
        },
        children: t == null ? void 0 : t.subTitle
      })]
    })
  }));
  return /* @__PURE__ */ n(X, {
    hideScrollbar: !e.verticalScrollbar,
    children: /* @__PURE__ */ n(R, {
      $style: i,
      children: /* @__PURE__ */ n(q, {
        mode: (e == null ? void 0 : e.mode) || "left",
        reverse: e == null ? void 0 : e.reverse,
        pending: (e == null ? void 0 : e.pending) && /* @__PURE__ */ n("span", {
          style: {
            color: i == null ? void 0 : i.titleColor
          },
          children: (e == null ? void 0 : e.pending) || ""
        }),
        items: k
      })
    })
  });
};
let b = function() {
  return new M(_, (e, l) => /* @__PURE__ */ n(ee, {
    ...e,
    dispatch: l
  })).setPropertyViewFn((e) => /* @__PURE__ */ c(h, {
    children: [/* @__PURE__ */ n(d, {
      name: m.basic,
      children: e.value.propertyView({
        label: o("timeLine.value"),
        tooltip: K,
        placeholder: "[]"
      })
    }), ["logic", "both"].includes(p(f).editorModeStatus) && /* @__PURE__ */ c(d, {
      name: m.interaction,
      children: [e.onEvent.getPropertyView(), A(e), N(e)]
    }), ["layout", "both"].includes(p(f).editorModeStatus) && /* @__PURE__ */ c(h, {
      children: [/* @__PURE__ */ c(d, {
        name: m.layout,
        children: [e.autoHeight.getPropertyView(), !e.autoHeight.getView() && e.verticalScrollbar.propertyView({
          label: o("prop.showVerticalScrollbar")
        }), e.mode.propertyView({
          label: o("timeLine.mode"),
          tooltip: o("timeLine.modeTooltip")
        }), e.pending.propertyView({
          label: o("timeLine.pending"),
          tooltip: o("timeLine.pendingDescription")
        }), e.reverse.propertyView({
          label: o("timeLine.reverse")
        })]
      }), /* @__PURE__ */ n(d, {
        name: m.style,
        children: e.style.getPropertyView()
      })]
    })]
  })).build();
}();
b = class extends b {
  autoHeight() {
    return this.children.autoHeight.getView();
  }
};
const ce = U(b, [new g("value", o("timeLine.valueDesc")), new g("clickedObject", o("timeLine.clickedObjectDesc")), new g("clickedIndex", o("timeLine.clickedIndexDesc")), G]);
export {
  ce as TimeLineComp
};
