import { W as ie, w as D, a4 as o, X as x, bY as re, a9 as se, V as F, cf as M, a5 as C, cg as me, aH as de, ch as ue, ci as ce, cj as fe, aa as ye, S as Se, ab as g, ck as k, U as H, cl as y, dV as S, H as c, dW as Z, c6 as U, ad as d, I as T, ae as n, af as i, co as W, an as r, cp as A, cC as j, cD as K, c1 as N, ah as L, ag as $, cq as _, c4 as G, cs as he, ai as X, ak as z, ct as w, c2 as Y, cv as Ve, cw as ge, P as we, _ as ve, cx as Ze, cy as Te, cz as be, cF as Ce, cG as xe, cH as Re } from "./c8cb6565.js";
import { useState as O, useEffect as v, useContext as s } from "react";
import { disabledTime as J, handleDateChange as Pe, dateRefMethods as Q } from "./69365736.js";
import { TimeUIView as Fe } from "./d12dc681.js";
import { TimeRangeUIView as Ee } from "./c8fc9dea.js";
import { timeZoneOptions as Ie } from "./954f6cfa.js";
import { fixOldDateOrTimeRangeData as De } from "./75d8dd85.js";
import "react-dom";
import "./54762cf9.js";
import "./64753d10.js";
import "./ff75f540.js";
const Me = [Ce, xe, Re], ze = {
  showValidationWhenEmpty: F,
  required: F,
  minTime: x,
  maxTime: x,
  customRule: ge
}, p = {
  label: ie,
  placeholder: D(x, o("time.placeholder")),
  format: x,
  inputFormat: D(x, Z),
  disabled: re,
  onEvent: se(Me),
  showTime: F,
  use12Hours: F,
  hourStep: M.closed(1, 24, 1),
  minuteStep: M.closed(1, 60, 1),
  secondStep: M.closed(1, 60, 1),
  style: C(me, "style"),
  animationStyle: C(de, "animationStyle"),
  labelStyle: C(ue.filter((e) => ["accent", "validate"].includes(e.name) === !1), "labelStyle"),
  inputFieldStyle: C(ce, "inputFieldStyle"),
  childrenInputFieldStyle: C(fe, "childrenInputFieldStyle"),
  suffixIcon: D(we, "/icon:regular/clock"),
  timeZone: ye(Ie, Intl.DateTimeFormat().resolvedOptions().timeZone),
  viewRef: Se,
  ...ze
}, ee = (e) => ve.pick(e, "format", "inputFormat", "use12Hours", "minuteStep", "secondStep", "placeholder"), te = (e) => [Ze(e), Te(e), be(e)];
function b(e) {
  if (e.customRule)
    return {
      validateStatus: "error",
      help: e.customRule
    };
  const t = y(e.value.value, S);
  return e.required && (!e.value.value || !t.isValid()) ? {
    validateStatus: "error",
    help: o("prop.required")
  } : {
    validateStatus: "success"
  };
}
const Oe = {
  defaultValue: g("defaultValue"),
  value: g("value"),
  userTimeZone: g("userTimeZone", Intl.DateTimeFormat().resolvedOptions().timeZone),
  ...p,
  ...k
}, qe = new H(Oe, (e) => {
  const t = {
    ...e.defaultValue
  }.value, a = {
    ...e.value
  }.value;
  let l = null;
  a !== "" && (l = y(a, S));
  const [m, f] = O(l);
  v(() => {
    e.value.onChange(t);
  }, [t]), v(() => {
    const u = a ? y(a, S) : null;
    f(u);
  }, [a]);
  const V = (u) => {
    e.userTimeZone.onChange(u);
  };
  return e.label({
    required: e.required,
    style: e.style,
    labelStyle: e.labelStyle,
    inputFieldStyle: e.inputFieldStyle,
    animationStyle: e.animationStyle,
    onMouseDown: (u) => u.stopPropagation(),
    children: /* @__PURE__ */ c(Fe, {
      handleTimeZoneChange: V,
      timeZone: e == null ? void 0 : e.timeZone,
      viewRef: e.viewRef,
      $style: e.inputFieldStyle,
      $childrenInputFieldStyle: e.childrenInputFieldStyle,
      disabled: e.disabled,
      value: m != null && m.isValid() ? m : null,
      disabledTime: () => J(e.minTime, e.maxTime),
      ...ee(e),
      hourStep: e.hourStep,
      minuteStep: e.minuteStep,
      secondStep: e.secondStep,
      placeholder: e.placeholder,
      onChange: (u) => {
        Pe(u && u.isValid() ? u.format(Z) : "", e.value.onChange, e.onEvent);
      },
      onFocus: () => e.onEvent("focus"),
      onBlur: () => e.onEvent("blur"),
      suffixIcon: U(e.suffixIcon) && e.suffixIcon
    }),
    showValidationWhenEmpty: e.showValidationWhenEmpty,
    ...b(e)
  });
}).setPropertyViewFn((e) => /* @__PURE__ */ d(T, {
  children: [/* @__PURE__ */ d(n, {
    name: i.basic,
    children: [e.defaultValue.propertyView({
      label: o("prop.defaultValue"),
      tooltip: o("time.formatTip")
    }), e.timeZone.propertyView({
      label: o("prop.timeZone")
    })]
  }), /* @__PURE__ */ c(W, {
    ...e
  }), (s(r).editorModeStatus === "logic" || s(r).editorModeStatus === "both") && /* @__PURE__ */ d(T, {
    children: [/* @__PURE__ */ d(n, {
      name: i.validation,
      children: [A(e), e.showValidationWhenEmpty.propertyView({
        label: o("prop.showEmptyValidation")
      }), j(e), K(e), e.customRule.propertyView({})]
    }), /* @__PURE__ */ d(n, {
      name: i.interaction,
      children: [e.onEvent.getPropertyView(), N(e), L(e), $(e)]
    })]
  }), (s(r).editorModeStatus === "layout" || s(r).editorModeStatus === "both") && e.label.getPropertyView(), (s(r).editorModeStatus === "layout" || s(r).editorModeStatus === "both") && /* @__PURE__ */ d(n, {
    name: i.layout,
    children: [_({
      children: e,
      placeholder: Z
    }), e.placeholder.propertyView({
      label: o("time.placeholderText")
    })]
  }), (s(r).editorModeStatus === "logic" || s(r).editorModeStatus === "both") && /* @__PURE__ */ d(n, {
    name: i.advanced,
    children: [te(e), e.use12Hours.propertyView({
      label: o("prop.use12Hours")
    }), e.suffixIcon.propertyView({
      label: o("button.suffixIcon")
    })]
  }), (s(r).editorModeStatus === "layout" || s(r).editorModeStatus === "both") && /* @__PURE__ */ d(T, {
    children: [/* @__PURE__ */ c(n, {
      name: i.style,
      children: e.style.getPropertyView()
    }), /* @__PURE__ */ c(n, {
      name: i.labelStyle,
      children: e.labelStyle.getPropertyView()
    }), /* @__PURE__ */ c(n, {
      name: i.inputFieldStyle,
      children: e.inputFieldStyle.getPropertyView()
    }), /* @__PURE__ */ c(n, {
      name: i.childrenInputFieldStyle,
      children: e.childrenInputFieldStyle.getPropertyView()
    }), /* @__PURE__ */ c(n, {
      name: i.animationStyle,
      hasTooltip: !0,
      children: e.animationStyle.getPropertyView()
    })]
  })]
})).setExposeMethodConfigs(Q).build(), Be = G(qe, he), ke = function() {
  const e = {
    defaultStart: g("defaultStart"),
    start: g("start"),
    defaultEnd: g("defaultEnd"),
    end: g("end"),
    userRangeTimeZone: g("userRangeTimeZone", Intl.DateTimeFormat().resolvedOptions().timeZone),
    ...k,
    ...p
  };
  return new H(e, (t) => {
    const a = {
      ...t.defaultStart
    }.value, l = {
      ...t.start
    }.value, m = {
      ...t.defaultEnd
    }.value, f = {
      ...t.end
    }.value;
    let V = null;
    l !== "" && (V = y(l, S));
    let u = null;
    f !== "" && (u = y(f, S));
    const [R, oe] = O(V), [P, le] = O(u);
    v(() => {
      t.start.onChange(a);
    }, [a]), v(() => {
      t.end.onChange(m);
    }, [m]), v(() => {
      const h = l ? y(l, S) : null;
      oe(h);
    }, [l]), v(() => {
      const h = f ? y(f, S) : null;
      le(h);
    }, [f]);
    const ne = /* @__PURE__ */ c(Ee, {
      handleTimeRangeZoneChange: (h) => {
        t.userRangeTimeZone.onChange(h);
      },
      timeZone: t == null ? void 0 : t.timeZone,
      viewRef: t.viewRef,
      $style: t.inputFieldStyle,
      $childrenInputFieldStyle: t.childrenInputFieldStyle,
      disabled: t.disabled,
      start: R != null && R.isValid() ? R : null,
      end: P != null && P.isValid() ? P : null,
      disabledTime: () => J(t.minTime, t.maxTime),
      ...ee(t),
      hourStep: t.hourStep,
      minuteStep: t.minuteStep,
      secondStep: t.secondStep,
      placeholder: [t.placeholder, t.placeholder],
      onChange: (h, I) => {
        t.start.onChange(h && h.isValid() ? h.format(Z) : ""), t.end.onChange(I && I.isValid() ? I.format(Z) : ""), t.onEvent("change");
      },
      onFocus: () => t.onEvent("focus"),
      onBlur: () => t.onEvent("blur"),
      suffixIcon: U(t.suffixIcon) && t.suffixIcon
    }), E = b({
      ...t,
      value: t.start
    }), q = b({
      ...t,
      value: t.end
    });
    return t.label({
      required: t.required,
      style: t.style,
      labelStyle: t.labelStyle,
      inputFieldStyle: t.inputFieldStyle,
      animationStyle: t.animationStyle,
      children: ne,
      onMouseDown: (h) => h.stopPropagation(),
      showValidationWhenEmpty: t.showValidationWhenEmpty,
      ...E.validateStatus !== "success" ? E : q.validateStatus !== "success" ? q : E
    });
  }).setPropertyViewFn((t) => /* @__PURE__ */ d(T, {
    children: [/* @__PURE__ */ d(n, {
      name: i.basic,
      children: [t.defaultStart.propertyView({
        label: o("time.start"),
        tooltip: o("time.formatTip")
      }), t.defaultEnd.propertyView({
        label: o("time.end"),
        tooltip: o("time.formatTip")
      }), t.timeZone.propertyView({
        label: o("prop.timeZone")
      })]
    }), /* @__PURE__ */ c(W, {
      ...t
    }), (s(r).editorModeStatus === "logic" || s(r).editorModeStatus === "both") && /* @__PURE__ */ d(T, {
      children: [/* @__PURE__ */ d(n, {
        name: i.validation,
        children: [A(t), t.showValidationWhenEmpty.propertyView({
          label: o("prop.showEmptyValidation")
        }), j(t), K(t), t.customRule.propertyView({})]
      }), /* @__PURE__ */ d(n, {
        name: i.interaction,
        children: [t.onEvent.getPropertyView(), N(t), L(t), $(t)]
      })]
    }), (s(r).editorModeStatus === "layout" || s(r).editorModeStatus === "both") && t.label.getPropertyView(), (s(r).editorModeStatus === "layout" || s(r).editorModeStatus === "both") && /* @__PURE__ */ d(n, {
      name: i.layout,
      children: [_({
        children: t,
        placeholder: Z
      }), t.placeholder.propertyView({
        label: o("time.placeholderText")
      })]
    }), (s(r).editorModeStatus === "logic" || s(r).editorModeStatus === "both") && /* @__PURE__ */ d(n, {
      name: i.advanced,
      children: [te(t), t.use12Hours.propertyView({
        label: o("prop.use12Hours")
      }), t.suffixIcon.propertyView({
        label: o("button.suffixIcon")
      })]
    }), (s(r).editorModeStatus === "layout" || s(r).editorModeStatus === "both") && /* @__PURE__ */ d(T, {
      children: [/* @__PURE__ */ c(n, {
        name: i.style,
        children: t.style.getPropertyView()
      }), /* @__PURE__ */ c(n, {
        name: i.labelStyle,
        children: t.labelStyle.getPropertyView()
      }), /* @__PURE__ */ c(n, {
        name: i.inputFieldStyle,
        children: t.inputFieldStyle.getPropertyView()
      }), /* @__PURE__ */ c(n, {
        name: i.childrenInputFieldStyle,
        children: t.childrenInputFieldStyle.getPropertyView()
      }), /* @__PURE__ */ c(n, {
        name: i.animationStyle,
        hasTooltip: !0,
        children: t.animationStyle.getPropertyView()
      })]
    })]
  })).build();
}(), He = G(ke, De), ae = (e, t) => {
  var V;
  const a = e === "UserChoice" ? t : e, m = y().tz(a).format("Z"), f = (V = new Intl.DateTimeFormat("en-US", {
    timeZone: a,
    timeZoneName: "short"
  }).formatToParts().find((u) => u.type === "timeZoneName")) == null ? void 0 : V.value;
  return {
    TimeZone: a,
    Offset: m,
    Name: f
  };
}, Je = X(Be, [new z("value", o("export.timePickerValueDesc")), w({
  name: "formattedValue",
  desc: o("export.timePickerFormattedValueDesc"),
  depKeys: ["value", "format", "timeZone", "userTimeZone"],
  func: (e) => {
    const t = e.value ? y(e.value, S) : null, a = e.timeZone === "UserChoice" ? e.userTimeZone : e.timeZone, l = t == null ? void 0 : t.clone().tz(a, !0), m = l == null ? void 0 : l.format(e == null ? void 0 : e.format);
    return t != null && t.isValid() ? !e.format || e.format.includes("Z") || e.format.includes("z") ? m : t.format(e.format) : "";
  }
}), w({
  name: "timeZone",
  desc: o("export.timeZoneDesc"),
  depKeys: ["timeZone", "userTimeZone"],
  func: (e) => ae(e.timeZone, e.userTimeZone)
}), w({
  name: "invalid",
  desc: o("export.invalidDesc"),
  depKeys: ["value", "required", "minTime", "maxTime", "customRule"],
  func: (e) => b({
    ...e,
    value: {
      value: e.value
    }
  }).validateStatus !== "success"
}), ...Y]);
let B = X(He, [new z("start", o("export.timeRangeStartDesc")), new z("end", o("export.timeRangeEndDesc")), w({
  name: "formattedValue",
  desc: o("export.timeRangeFormattedValueDesc"),
  depKeys: ["start", "end", "format", "timeZone", "userRangeTimeZone"],
  func: (e) => {
    const t = e.start ? y(e.start, S) : null, a = e.end ? y(e.end, S) : null, l = e.timeZone === "UserChoice" ? e.userRangeTimeZone : e.timeZone, m = t == null ? void 0 : t.clone().tz(l, !0), f = a == null ? void 0 : a.clone().tz(l, !0);
    return [t != null && t.isValid() && (!e.format || e.format.includes("Z") || e.format.includes("z")) ? m == null ? void 0 : m.format(e == null ? void 0 : e.format) : t == null ? void 0 : t.format(e.format), a != null && a.isValid() && (!e.format || e.format.includes("Z") || e.format.includes("z")) ? f == null ? void 0 : f.format(e == null ? void 0 : e.format) : a == null ? void 0 : a.format(e.format)].filter((V) => V).join(" - ");
  }
}), w({
  name: "formattedStartValue",
  desc: o("export.timeRangeFormattedStartValueDesc"),
  depKeys: ["start", "format", "timeZone", "userRangeTimeZone"],
  func: (e) => {
    const t = e.start ? y(e.start, S) : null, a = e.timeZone === "UserChoice" ? e.userRangeTimeZone : e.timeZone, l = t == null ? void 0 : t.clone().tz(a, !0), m = l == null ? void 0 : l.format(e == null ? void 0 : e.format);
    return t != null && t.isValid() && (!e.format || e.format.includes("Z") || e.format.includes("z")) ? m : t == null ? void 0 : t.format(e.format);
  }
}), w({
  name: "formattedEndValue",
  desc: o("export.timeRangeFormattedEndValueDesc"),
  depKeys: ["end", "format", "timeZone", "userRangeTimeZone"],
  func: (e) => {
    const t = e.end ? y(e.end, S) : null, a = e.timeZone === "UserChoice" ? e.userRangeTimeZone : e.timeZone, l = t == null ? void 0 : t.clone().tz(a, !0);
    return t != null && t.isValid() && (!e.format || e.format.includes("Z") || e.format.includes("z")) ? l == null ? void 0 : l.format(e == null ? void 0 : e.format) : t == null ? void 0 : t.format(e.format);
  }
}), w({
  name: "timeZone",
  desc: o("export.timeZoneDesc"),
  depKeys: ["timeZone", "userRangeTimeZone"],
  func: (e) => ae(e.timeZone, e.userRangeTimeZone)
}), w({
  name: "invalid",
  desc: o("export.invalidDesc"),
  depKeys: ["start", "end", "required", "minTime", "maxTime", "customRule"],
  func: (e) => b({
    ...e,
    value: {
      value: e.start
    }
  }).validateStatus !== "success" || b({
    ...e,
    value: {
      value: e.end
    }
  }).validateStatus !== "success"
}), ...Y]);
B = Ve(B, [...Q, {
  method: {
    name: "clearAll",
    description: o("date.clearAllDesc"),
    params: []
  },
  execute: (e) => {
    e.children.start.getView().onChange(""), e.children.end.getView().onChange("");
  }
}, {
  method: {
    name: "resetAll",
    description: o("date.resetAllDesc"),
    params: []
  },
  execute: (e) => {
    e.children.start.getView().reset(), e.children.end.getView().reset();
  }
}, {
  method: {
    name: "setRange",
    params: []
  },
  execute: (e, t) => {
    if (t.length !== 1)
      return Promise.reject(o("formComp.valuesLengthError"));
    const a = t[0];
    if (typeof a != "object" || a === null || Array.isArray(a) || !a.hasOwnProperty("start") || !a.hasOwnProperty("end"))
      return Promise.reject(o("formComp.valueTypeError"));
    e.children.start.getView().onChange(a.start), e.children.end.getView().onChange(a.end);
  }
}]);
export {
  Je as TimePickerComp,
  B as TimeRangeComp,
  Be as timePickerControl,
  He as timeRangeControl
};
