import { aD as d, a3 as g, a4 as t, a9 as u, dG as b, ab as p, a5 as w, hb as h, hc as y, aa as P, V as c, w as f, ei as C, U as m, H as r, _ as x, ad as i, I as v, ae as o, af as l, co as k, c1 as V, ag as $, ah as S, ak as s, cF as E, hd as j } from "./c8cb6565.js";
import "react";
import { presets as A } from "./f46b942c.js";
import "react-dom";
function D(e) {
  return d`
    border-radius: ${e.radius};
    &:not(.ant-input-disabled, .ant-input-affix-wrapper-disabled),
    input {
      background-color: ${e.background};
      color:${e.text};
      font-weight:${e.textWeight};
      font-family:${e.fontFamily};
      border-color: ${e.border};
      &:focus,
      &.ant-input-affix-wrapper-focused {
        border-color: ${e.accent};
      }
      &:hover {
        border-color: ${e.accent};
      }
      .ant-input-clear-icon svg:hover {
        opacity: 0.65;
      }
    }
  `;
}
const H = g(j)`
  width: 100%;
  display: flex;
  justify-content: flex-start;
  ${(e) => e.$style && D(e.$style)}
`, O = [{
  label: t("colorPicker.click"),
  value: "click"
}, {
  label: t("colorPicker.hover"),
  value: "hover"
}], F = u([E]), U = {
  ...b,
  value: p("value", "#3377ff"),
  style: w(h, "style"),
  color: y("color", {}),
  trigger: P(O, "click"),
  disabledAlpha: c,
  showPresets: c,
  onEvent: F,
  presets: f(C, JSON.stringify(A, null, 2))
}, T = new m(U, (e) => {
  var n;
  return e.label({
    children: /* @__PURE__ */ r(H, {
      $style: e.style,
      value: (n = e == null ? void 0 : e.value) == null ? void 0 : n.value,
      disabledAlpha: e.disabledAlpha,
      showText: (a) => a.toHexString().toUpperCase(),
      allowClear: !0,
      trigger: e.trigger,
      disabled: e.disabled,
      onChange: (a) => {
        e.value.onChange(a.toHexString().toUpperCase()), e.color.onChange({
          hex: a.toHexString().toUpperCase(),
          hsb: a.toHsb(),
          rgb: a.toRgb()
        }), e.onEvent("change");
      },
      presets: e.showPresets && !x.isEmpty(e.presets) ? [e.presets] : []
    }),
    style: e.style
  });
}).setPropertyViewFn((e) => /* @__PURE__ */ i(v, {
  children: [/* @__PURE__ */ r(o, {
    name: l.basic,
    children: e.value.propertyView({
      label: t("prop.defaultValue")
    })
  }), /* @__PURE__ */ r(k, {
    ...e
  }), e.label.getPropertyView(), /* @__PURE__ */ i(o, {
    name: l.interaction,
    children: [e.onEvent.getPropertyView(), V(e), $(e)]
  }), /* @__PURE__ */ i(o, {
    name: l.advanced,
    children: [e.trigger.propertyView({
      label: t("colorPicker.trigger"),
      radioButton: !0
    }), e.disabledAlpha.propertyView({
      label: t("colorPicker.disabledAlpha")
    }), e.showPresets.propertyView({
      label: t("colorPicker.showPresets")
    }), e.showPresets.getView() && e.presets.propertyView({
      label: t("colorPicker.recommended")
    })]
  }), /* @__PURE__ */ r(o, {
    name: l.layout,
    children: S(e)
  }), /* @__PURE__ */ r(o, {
    name: l.style,
    children: e.style.getPropertyView()
  })]
})).setExposeStateConfigs([new s("value", t("export.inputValueDesc")), new s("color", t("export.inputValueDesc")), new s("disabled", t("prop.disabled"))]).build();
export {
  T as ColorPickerComp,
  F as colorPickerEvent,
  D as getStyle
};
